"use strict";
const pluginName = "ResolveTypescriptPlugin";
class ResolveTypescriptPlugin {
    constructor(options = {}) {
        this.options = Object.assign(Object.assign({}, ResolveTypescriptPlugin.defaultOptions), options);
    }
    apply(resolver) {
        const target = resolver.ensureHook("file");
        for (const extension of [".ts", ".tsx"]) {
            resolver
                .getHook("raw-file")
                .tapAsync(pluginName, (request, resolveContext, callback) => {
                if (!request.path ||
                    (!this.options.includeNodeModules &&
                        request.path.match(/(^|[\\/])node_modules($|[\\/])/))) {
                    return callback();
                }
                const path = request.path.replace(/\.jsx?$/, extension);
                if (path === request.path) {
                    callback();
                }
                else {
                    resolver.doResolve(target, Object.assign(Object.assign({}, request), { path, relativePath: request.relativePath &&
                            request.relativePath.replace(/\.jsx?$/, extension) }), `using path: ${path}`, resolveContext, callback);
                }
            });
        }
    }
}
/** @deprecated For backwards compatibility with versions < v1.2.
 * Will be removed in v2.0. */
ResolveTypescriptPlugin.default = ResolveTypescriptPlugin;
ResolveTypescriptPlugin.defaultOptions = {
    includeNodeModules: false
};
module.exports = ResolveTypescriptPlugin;
//# sourceMappingURL=index.js.map